<?php
function intasend_register_settings_callback(){
    add_option('publishable_key', '');
    add_option('wpi_default_amount', '10');
    add_option('redirect_url', '');
    register_setting('intasend_options_group', 'publishable_key', 'intasend_callback');
    register_setting('intasend_options_group', 'wpi_default_amount', 'intasend_callback');
    register_setting('intasend_options_group', 'redirect_url', 'intasend_callback');
    register_setting('intasend_options_group', 'live_key', 'intasend_callback');
}
add_action('admin_init', 'intasend_register_settings_callback');

function tt_add_menu_items_callback(){
    add_menu_page(
        'IntaSend Payment Buttons',
        'IntaSend Payment',
        'activate_plugins',
        'instasend_shortcode_list',
        'tt_render_list_page_callback'
    );

    add_submenu_page(
        'instasend_shortcode_list',
        'IntaSend Payment Buttons',
        'Add New Shortcode',
        'activate_plugins',
        'instasend_add_button',
        'wps_get_button_form_callback'
    );

    add_submenu_page(
        'instasend_shortcode_list', 
        'IntaSend Payment Buttons', 
        'Settings', 
        'activate_plugins', 
        'instasend_settings', 
        'wps_get_settings_form_callback'
    );
}
add_action('admin_menu', 'tt_add_menu_items_callback');

function wps_get_settings_form_callback(){
    include('settings_form.php');
}

function wps_get_button_form_callback(){
    if( !get_option('publishable_key') || !get_option('redirect_url') ){
        wp_redirect('admin.php?page=instasend_settings');
        exit();
    }
    include('button_form.php');
}

function tt_render_list_page_callback(){
    
    if( !get_option('publishable_key') || !get_option('redirect_url') ){
        wp_redirect('admin.php?page=instasend_settings');
        exit();
    }

    $buttonsListTable = new ButtonsListTable();
    $buttonsListTable->prepare_items();
?>
    <div class="wrap">
        <div id="icon-users" class="icon32"><br /></div>
        <h2>Payment Buttons</h2>
        <form id="buttons-filter" method="get">
            <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
            <?php $buttonsListTable->display() ?>
        </form>
    </div>
<?php
}
?>