<?php
if (!class_exists('WP_List_Table')) {
    require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');
    require_once(ABSPATH . 'wp-admin/includes/screen.php');
    require_once(ABSPATH . 'wp-admin/includes/class-wp-screen.php');
    require_once(ABSPATH . 'wp-admin/includes/template.php');

    class ButtonsListTable extends WP_List_Table{
        function __construct(){
            global $status, $page;
            //Set parent defaults
            parent::__construct(array(
                'singular'  => 'button',
                'plural'    => 'buttons',
                'ajax'      => false
            ));
        }

        function column_default($item, $column_name){
            switch ($column_name) {
                case 'shortcode':
                    return $item[$column_name];
                case 'label':
                    return $item[$column_name];
                case 'currency':
                    return $item[$column_name];
                case 'amount':
                    return $item[$column_name];
                case 'method':
                    return $item[$column_name];
                case 'card_tarrif':
                    return $item[$column_name];
                case 'mobile_tarrif':
                    return $item[$column_name];
                default:
                    return print_r($item, true);
            }
        }

        function column_cb($item){
            return sprintf(
                '<input type="checkbox" name="%1$s[]" value="%2$s" />',
                /*$1%s*/
                $this->_args['singular'],
                /*$2%s*/
                $item['ID']
            );
        }

        function get_columns(){
            $columns = array(
                'cb'            => '<input type="checkbox" />',
                'shortcode'     => 'ShortCode',
                'label'         => 'Button Label',
                'currency'      => 'Currency',
                'amount'        => 'Amount',
                'method'        => 'Method',
                'card_tarrif'   => 'Card Tarrif',
                'mobile_tarrif' => 'Mobile Tarrif'
            );
            return $columns;
        }

        function get_sortable_columns(){
            $sortable_columns = array(
                'shortcode'     => array('shortcode', false),
                'label'         => array('label', false),
                'currency'      => array('currency', false),
                'amount'        => array('amount', false),
                'method'        => array('method', false),
                'card_tarrif'   => array('card_tarrif', false),
                'mobile_tarrif' => array('mobile_tarrif', false)
            );
            return $sortable_columns;
        }

        function get_bulk_actions(){
            $actions = array(
                'delete'    => 'Delete'
            );
            return $actions;
        }

        function process_bulk_action(){

            //Detect when a bulk action is being triggered...
            if ('delete' === $this->current_action()) {
                foreach ($_GET['button'] as $fID) {
                    global $wpdb;
                    $table = INTASEND_TABLE_PREFIX . "intasend_payment_codes_v1";
                    $wpdb->delete($table, array('id' => $fID));
                }
                echo '<script>window.location.href = "../wp-admin/admin.php?page=instasend_shortcode_list";</script>';
            }
        }

        function prepare_items(){
            global $wpdb; //This is used only if making any database queries
            $per_page   = 10;
            $columns    = $this->get_columns();
            $table_data = $hidden  = array();
            $sortable   = $this->get_sortable_columns();
            $table      = INTASEND_TABLE_PREFIX . "intasend_payment_codes_v1";

            $this->_column_headers = array($columns, $hidden, $sortable);
            $this->process_bulk_action();
            $records = $wpdb->get_results("SELECT * FROM $table");

            foreach ($records as $record) {
                if (isset($record->payment_amount) && isset($record->payment_currency)) {
                    $table_data[] = array(
                        "ID"            => $record->id,
                        "shortcode"     => '<b><h4>[intasend_payment id=' . $record->id . ']</h4></b>',
                        "label"         => $record->button_label,
                        "currency"      => $record->payment_currency,
                        "amount"        => $record->payment_amount,
                        "method"        => $record->method,
                        "card_tarrif"   => $record->card_tarrif,
                        "mobile_tarrif" => $record->mobile_tarrif
                    );
                }
            }

            $data = $table_data;
            
            function usort_reorder($a, $b){
                $orderby = (!empty($_REQUEST['orderby'])) ? $_REQUEST['orderby'] : 'shortcode';
                $order = (!empty($_REQUEST['order'])) ? $_REQUEST['order'] : 'asc';
                $result = strcmp($a[$orderby], $b[$orderby]);
                return ($order === 'asc') ? $result : -$result;
            }

            usort($data, 'usort_reorder');
            $current_page   = $this->get_pagenum();
            $total_items    = count($data);
            $data           = array_slice($data, (($current_page - 1) * $per_page), $per_page);
            $this->items    = $data;

            $this->set_pagination_args(array(
                'total_items' => $total_items,
                'per_page'    => $per_page,
                'total_pages' => ceil($total_items / $per_page)
            ));
        }
    }
}
?>