<?php
/**
 * Plugin Name:       IntaSend Payment - WordPress Plugin (NEW)
 * Plugin URI:        https://intasend.com/ 
 * Description:       Collect Card and Mobile Payments using IntaSend Payment Gateway.  
 * Version:           1.0.1
 * Requires at least: 5.2
 * Requires PHP:      7.2
 * Tested up to:      6.2
 * Author:            IntaSend Solutions Limited
 * Author URI:        https://intasend.com/
 * License:           GPL v2 or later
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.html
 * Update URI:        https://intasend.com/ 
 */

global $wpdb;
$table_prefix   = $wpdb->prefix;

define('INTASEND_PRINTMETHOD_FILE_PATH', dirname(__FILE__));
define('INTASEND_TABLE_PREFIX', $table_prefix);

/*
    Load necessary files for the plugin
*/
function intasend_plugin_loaded_init(){
    if(is_admin()){
        include_once INTASEND_PRINTMETHOD_FILE_PATH."/admin/class.ButtonsListTable.php";
        include_once INTASEND_PRINTMETHOD_FILE_PATH."/admin/admin-settings.php";    
    }
    include_once INTASEND_PRINTMETHOD_FILE_PATH."/shortcode.php";
}
add_action( 'plugins_loaded', 'intasend_plugin_loaded_init', 0 );


/*
    Create table on plugin activation
*/
function on_install_callback(){
    global $wpdb;
    $table     = INTASEND_TABLE_PREFIX . "intasend_payment_codes_v1";
    $structure = "CREATE TABLE $table (
                 id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,                 
                 shortcode_data VARCHAR(40) NOT NULL,                
                 payment_currency VARCHAR(3) NOT NULL,  
                 button_label VARCHAR(40) NOT NULL,          
                 payment_amount INT(11) NOT NULL,                
                 method VARCHAR(40) NOT NULL,                
                 card_tarrif VARCHAR(40) NOT NULL,               
                 mobile_tarrif VARCHAR(40) NOT NULL,                 
                 is_active TINYINT(1) NOT NULL
                 );";
    $wpdb->query($structure);
}
register_activation_hook(__FILE__, 'on_install_callback');
